#include <stdlib.h>
#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#include "usb_config.h"
#include "USB/usb.h"
#include "USB/usb_host_bluetooth.h"
#include "user.h"
#include "Common/delay.h"
#include "xprintf.h"

#define PIN_CODE_DEFAULT	"0000"

#define	PWM_PRESCALER			T2_PS_1_64							// 16MHz/64
//#define	PWM_WIDTH				((GetSystemClock()/2)/(64*1000))	// 1KHz
#define	PWM_WIDTH				250									// 1KHz
#define	PWM_DIGITAL_RUN_DUTY	(PWM_WIDTH)							// 100% Duty
//#define	PWM_DIGITAL_RUN_DUTY	(PWM_WIDTH/2)						// 50% Duty
#define	ENABLE_KNIGHTRIDER		1

// Define the baud rate constants UART1
#define	UARTPARAM1			UARTPARAM_N81			//data=8bit parity=none stopbit=1bit

#define BAUDRATE1       	9600
#define	USE_RFCOMM_BAUDRATE	1						//0:baud rate as fixed 1:baud rate as RFCOMM parameter from Master
#define BRG_DIV1        	4
#define BRGH1           	1
// Define Hardware Flow Control UART1 (0:off 1:on)
#define	UART1_HW_FLOW		1
#define	UART1_TX_POLARITY	0						//MMɐ 0:ʏ 1:]
#define	UART1_RX_POLARITY	0						//MMɐ 0:ʏ 1:]

//ڑ@ (RVL-CNT-01-TRł1+2ł̐ڑ͂łȂ)
#define	WII_REMOTE_CONNECTION_SYNC	 0			//0:1+2Őڑ  1:W̒SYNC{^Őڑ

//WiiR̐ڑ҂ (WiiR̐ڑSYNCňxڑ̂݉\ASYNC1+2ł͐ڑłȂȂ)
#define	MODE_NO_INQUIRY				 0			//0:INQUIRYWiiRT 1:INQUIRYWiiR̐ڑ҂

//wiiR̃|[g[hݒ(g@Ȃ̏ꍇ)
#define	WII_REMOTE_REPORT_MODE		 0x31		//0x30:Core Buttons 0x31:Core Buttons and Accelerometer

//wiiR̃|[g[hݒ(g@킠̏ꍇ)	0x35Œ
#define	WII_REMOTE_REPORT_MODE_EXT	 0x35		//0x35:Core Buttons and Accelerometer with 16 Extension Bytes

// Define the baud rate constants UART2 (Debug)
#define BAUDRATE2       	115200
#define BRG_DIV2        	4
#define BRGH2           	1

// Define LED1 communication indicator on time(ms)
#define	LED1_ON_COUNT		10
#define	USE_RSSI			1						//0:blink rate as fixed 1:blink rate as RSSI (fast:lowRSSI slow:highRSSI)



#define LOCAL_NAME			"MPIC"
#define	ICSDEF				ICS_PGx1

#if	__DEBUG
//disable watchdog timer
#define	FWDTENDEF			FWDTEN_OFF
#define	RestartWatchdog()
#else
//enable watchdog timer
#define	FWDTENDEF			FWDTEN_ON
#define	RestartWatchdog()	ClrWdt()
#endif

// Configure LED1 - put on pin 13 (RA7)
#define	led1_setup()		(TRISAbits.TRISA7=0)
#define	led1_on()			(LATAbits.LATA7=0)	//ON
#define	led1_off()			(LATAbits.LATA7=1)	//OFF

// Configure LED2 - put on pin 32 (RA8)
#define	led2_setup()		(TRISAbits.TRISA8=0)
#define	led2_on()			(LATAbits.LATA8=0)	//ON
#define	led2_off()			(LATAbits.LATA8=1)	//OFF

// Configure LED3 - put on pin 35 (RA9)
#define	led3_setup()		(TRISAbits.TRISA9=0)
#define	led3_on()			(LATAbits.LATA9=0)	//ON
#define	led3_off()			(LATAbits.LATA9=1)	//OFF

// Configure LED4 - put on pin 12 (RA10)
#define	led4_setup()		(TRISAbits.TRISA10=0)
#define	led4_on()			(LATAbits.LATA10=0)	//ON
#define	led4_off()			(LATAbits.LATA10=1)	//OFF

// Configure LED5 - put on pin 34 (RA4)
#define	led5_setup()		(TRISAbits.TRISA4=0)
#define	led5_on()			(LATAbits.LATA4=0)	//ON
#define	led5_off()			(LATAbits.LATA4=1)	//OFF

//todo setup analog port
// Configure P1 Sensor analog in on pin 19 (AN0)
// Configure P2 Sensor analog in on pin 20 (AN1)
// Configure P3 Sensor analog in on pin 23 (AN4)
// Configure P4 Sensor analog in on pin 24 (AN5)
// Configure P5 Sensor analog in on pin 25 (AN6)
// Configure P6 Sensor analog in on pin 26 (AN7)

// Configure Motor Driver AIN1 on pin 37 (RC4)
#define	motor_a1_setup()	(TRISCbits.TRISC4=0)
#define	motor_a1_h()		(LATCbits.LATC4=1)	//H
#define	motor_a1_l()		(LATCbits.LATC4=0)	//L

// Configure Motor Driver AIN2 on pin 38 (RC5)
#define	motor_a2_setup()	(TRISCbits.TRISC5=0)
#define	motor_a2_h()		(LATCbits.LATC5=1)	//H
#define	motor_a2_l()		(LATCbits.LATC5=0)	//L

// Configure Motor Driver PWMA on pin 43 (RP7,RB7)
#define	motor_pwma_setup()	(TRISBbits.TRISB7=0,PPSOutput(PPS_RP7,PPS_OC1))
#define	motor_pwma_write(x)	(SetDCOC1PWM((x),0))

// Configure Motor Driver BIN1 on pin 2  (RC6)
#define	motor_b1_setup()	(TRISCbits.TRISC6=0)
#define	motor_b1_h()		(LATCbits.LATC6=1)	//H
#define	motor_b1_l()		(LATCbits.LATC6=0)	//L

// Configure Motor Driver BIN2 on pin 3  (RC7)
#define	motor_b2_setup()	(TRISCbits.TRISC7=0)
#define	motor_b2_h()		(LATCbits.LATC7=1)	//H
#define	motor_b2_l()		(LATCbits.LATC7=0)	//L

// Configure Motor Driver PWMB on pin 44 (RP8,RB8)
#define	motor_pwmb_setup()	(TRISBbits.TRISB8=0,PPSOutput(PPS_RP8,PPS_OC2))
#define	motor_pwmb_write(x)	(SetDCOC2PWM((x),0))

// Configure Switch1 on pin 30 (RA2,CN30)
#define	switch1_setup()		(EnablePullUpCN30,EnableCN30)
#define	get_switch1()		(PORTAbits.RA2)

// Configure Switch2 on pin 31 (RA3,CN29)
#define	switch2_setup()		(EnablePullUpCN29,EnableCN29)
#define	get_switch2()		(PORTAbits.RA3)

// Configure U1RX - put on pin 4 (RP24)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 24)
// Configure U1TX - put on pin 5 (RP25)
#define u1tx_setup()		(RPOR12bits.RP25R = 3)

#if	__DEBUG
#define	u1cts_setup()
// Configure console OUT(U2TX) - put on pin 1 (RP9)
#define	sto_setup()			(RPOR4bits.RP9R = 5)
#else
// Configure U1CTS - put on pin 1 (RP9)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 9)
#define	sto_setup()
#endif
// Configure U1RTS - put on pin 41 (RB5)
// U1RTS has software control
#define	u1rts_setup()		(TRISBbits.TRISB5=0)
#define	u1rts_on()			(LATBbits.LATB5=0)	//ON:rx ready
#define	u1rts_off()			(LATBbits.LATB5=1)	//OFF:rx not ready


#if	ENABLE_KNIGHTRIDER
// Configure KnightRider Bumper LED1 on pin 26 (RC1)
#define	kr_led1_setup()		(TRISCbits.TRISC1=0)
#define	kr_led1_on()		(LATCbits.LATC1=0)	//ON
#define	kr_led1_off()		(LATCbits.LATC1=1)	//OFF

// Configure KnightRider Bumper LED2 on pin 36 (RC3)
#define	kr_led2_setup()		(TRISCbits.TRISC3=0)
#define	kr_led2_on()		(LATCbits.LATC3=0)	//ON
#define	kr_led2_off()		(LATCbits.LATC3=1)	//OFF

// Configure KnightRider Bumper LED3 on pin 33 (RB4)
#define	kr_led3_setup()		(TRISBbits.TRISB4=0)
#define	kr_led3_on()		(LATBbits.LATB4=0)	//ON
#define	kr_led3_off()		(LATBbits.LATB4=1)	//OFF

// Configure KnightRider Bumper LED4 on pin 27 (RC2)
#define	kr_led4_setup()		(TRISCbits.TRISC2=0)
#define	kr_led4_on()		(LATCbits.LATC2=0)	//ON
#define	kr_led4_off()		(LATCbits.LATC2=1)	//OFF

// Configure KnightRider Bumper LED5 on pin 15 (RB15)
#define	kr_led5_setup()		(TRISBbits.TRISB15=0)
#define	kr_led5_on()		(LATBbits.LATB15=0)	//ON
#define	kr_led5_off()		(LATBbits.LATB15=1)	//OFF

// Configure KnightRider Bumper LED6 on pin 14 (RB14)
#define	kr_led6_setup()		(TRISBbits.TRISB14=0)
#define	kr_led6_on()		(LATBbits.LATB14=0)	//ON
#define	kr_led6_off()		(LATBbits.LATB14=1)	//OFF

// Configure KnightRider Bumper LED7 on pin 11 (RB13)
#define	kr_led7_setup()		(TRISBbits.TRISB13=0)
#define	kr_led7_on()		(LATBbits.LATB13=0)	//ON
#define	kr_led7_off()		(LATBbits.LATB13=1)	//OFF

// Configure KnightRider Bumper LED8 on pin 25 (RC0)
#define	kr_led8_setup()		(TRISCbits.TRISC0=0)
#define	kr_led8_on()		(LATCbits.LATC0=0)	//ON
#define	kr_led8_off()		(LATCbits.LATC0=1)	//OFF
#endif

#define Nop()    __builtin_nop()
#define ClrWdt() {__asm__ volatile ("clrwdt");}
#define Sleep()  {__asm__ volatile ("pwrsav #0");}
#define Idle()   {__asm__ volatile ("pwrsav #1");}

extern void (*usb_tick_handler)(void);
void	event_bluetooth_rxEvent_done(WORD size);
void	event_bluetooth_rxAcl_done(WORD size);

typedef WORD clock_t;
